/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        31.12.2007
 Description:    Analogeingnge Abfragen
 
 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "analog.h"


volatile unsigned char channel = 0;

//Fehlt in iox128a1.h:
#define NVM_PROD_SIGNATURES (*(NVM_PROD_SIGNATURES_t *) PROD_SIGNATURES_START) 
//------------------------------------------------------------------------------
uint8_t SP_ReadCalibrationByte( uint8_t index )
{
	uint8_t result;

	/* Load the NVM Command register to read the calibration row. */
	NVM_CMD = NVM_CMD_READ_CALIB_ROW_gc;
 	result = pgm_read_byte(index);

	/* Clean up NVM Command register. */
 	NVM_CMD = NVM_CMD_NO_OPERATION_gc;

	return result;
}


//------------------------------------------------------------------------------

#if defined (__atxmega128a1__)
void DAC_Init(void){ 
  PORTB.DIRSET = 4|8;  //PB2+3 
  DACB.CTRLB = DAC_CHSEL_DUAL_gc
            // | 3  //Autotrigger CH0 und 1
             ;
  DACB.CTRLC = DAC_REFSEL_INT1V_gc;
  //DACB.CTRLC = DAC_REFSEL_AVCC_gc;
  
  //DACB.EVCTRL = ?  unbenutzt

  DACB.TIMCTRL = DAC_CONINTVAL_128CLK_gc
              | DAC_REFRESH_1024CLK_gc
              ;

  DACB.GAINCAL = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.DACBGAINCAL);
  DACB.OFFSETCAL = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.DACBOFFCAL);

  DACB.CTRLA = DAC_CH1EN_bm | DAC_CH0EN_bm | DAC_ENABLE_bm;
  //Daten in DACB.CH0DATA und DACB.CH1DATA
}
#endif



//------------------------------------------------------------------------------
//
void ADC_Init(void)
{ 
#if defined (__atxmega128a1__)
/*  
  #ifndef ADCACAL0_offset

  #define ADCACAL0_offset 0x20
  #define ADCACAL1_offset 0x21
  #define ADCBCAL0_offset 0x24
  #define ADCBCAL1_offset 0x25
  #endif
*/    
    
  //--- ADC Kanal aufsetzen ---   
    
  ADCB.CH0.CTRL = 
                 ADC_CH_START_bm
                 //Default: GAIN = 1  (GAINFAC=0)
               | ADC_CH_INPUTMODE0_bm //Single ended
                 ;
  ADCB.CH0.MUXCTRL = 0; //000 -> PB0
  ADCB.CH0.INTCTRL = 0; //no int
  //ADCB.CH0.INTFLAGS
    
    
  ADCB.CH1.CTRL = 
                 ADC_CH_START_bm
                 //Default: GAIN = 1  (GAINFAC=0)
               | ADC_CH_INPUTMODE0_bm //Single ended
                 ;
  ADCB.CH1.MUXCTRL = ADC_CH_MUXPOS0_bm; //001 -> PB1
  ADCB.CH1.INTCTRL = 0; //no int
    
  ADCB.CH2.CTRL = 
                 ADC_CH_START_bm
                 //Default: GAIN = 1  (GAINFAC=0)
               | ADC_CH_INPUTMODE0_bm //Single ended
                 ;
  ADCB.CH2.MUXCTRL = ADC_CH_MUXPOS2_bm; //100 -> PB4
  ADCB.CH2.INTCTRL = 0; //no int
    
  ADCB.CH3.CTRL = 
                 ADC_CH_START_bm
                 //Default: GAIN = 1  (GAINFAC=0)
               | ADC_CH_INPUTMODE0_bm //Single ended
                 ;
  ADCB.CH3.MUXCTRL = ADC_CH_MUXPOS2_bm | ADC_CH_MUXPOS0_bm; //101 -> PB5 
  ADCB.CH3.INTCTRL = 0; //no int
    
  
    
    
  //--- ADC aufsetzen ---   
  ADCB.INTFLAGS = 0; //Keine Interrupts - ich benutze einfaches free running
  ADCB.REFCTRL = 0; //internal 1.00V  


	/* Get ADCBCAL0 from production signature  */
  //ADCB.CALL = SP_ReadCalibrationByte( PROD_SIGNATURES_START + ADCBCAL0_offset );
	//ADCB.CALH = SP_ReadCalibrationByte( PROD_SIGNATURES_START + ADCBCAL1_offset );

  ADCB.CALL = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.ADCBCAL0);
  ADCB.CALH = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.ADCBCAL1);

/*
debug1 = SP_ReadCalibrationByte( PROD_SIGNATURES_START + ADCBCAL0_offset );
debug2 = SP_ReadCalibrationByte( PROD_SIGNATURES_START + ADCBCAL1_offset );
debug3 = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.ADCBCAL0);
debug4 = SP_ReadCalibrationByte((uint16_t)&NVM_PROD_SIGNATURES.ADCBCAL1);
*/


  ADCB.EVCTRL = 
                ADC_SWEEP0_bm
              | ADC_SWEEP1_bm // Sweep CH 0..3
              // ADC_EVSEL0_bm //EVSEL=0-> Group 0123
              | ADC_EVACT2_bm
              //| ADC_EVACT1_bm
              | ADC_EVACT0_bm   //EVACT=101 -> SWEEP
              ; 
    
  ADCB.PRESCALER = ADC_PRESCALER_DIV512_gc; //so langsam wie's geht (62,5KHz ist immer noch schnell genug)
   
    
  ADCB.CTRLB = ADC_FREERUN_bm
             // 0 //Default= 12 Bit right adjust
             ;
    
  ADCB.CTRLA = ADC_ENABLE_bm 
             | ADC_CH0START_bm
             | ADC_CH1START_bm
             | ADC_CH2START_bm
             | ADC_CH3START_bm
             ; 
    
/*  Ergebnisse in ADCB.CHnRES, z.B.  ADCB.CH0RES*/


#else    
	ADMUX = (1<<REFS0) | (1<<ADLAR); //Left Adjust (wir nutzen nur 8 Bit)
	//Free Running Mode, Division Factor 128, Interrupt on
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
  	#if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
    	ADCSRB=0;
	#endif 
#endif 

}

//------------------------------------------------------------------------------
#if defined (__atxmega128a1__)

#else
//
ISR (ADC_vect)
{
#define GAS_HIGH gas_h
#define GAS_LOW  gas_l

#define WASSER_HIGH wasser_h
#define WASSER_LOW  wasser_l

#define STROM_HIGH strom_h
#define STROM_LOW  strom_l

static unsigned char Gaspegel=0;    //0 oder 1
static unsigned char Wasserpegel=0;
static unsigned char Strompegel=0;
unsigned char x;

  ANALOG_OFF; //ADC OFF
  x = ADCH;
  adc_array[channel]=x;
  switch (channel){
    case 0: //Gas
      if (!Gaspegel && (x > GAS_HIGH)){
        Gaspegel = 1;
        jetzt.Zaehlerstand_Gas++;
        verbrauch[viertelstunde].Gas++;
      }else
      if (Gaspegel && (x < GAS_LOW)){
        Gaspegel = 0;
      }
      if ( x > pegelMaxGas) pegelMaxGas = x;
      if ( x < pegelMinGas) pegelMinGas = x;
      channel=1;
      PORTC=Gaspegel;
      break;

    case 1: //Wasser
      if (!Wasserpegel && (x > WASSER_HIGH)){
        Wasserpegel = 1;
        jetzt.Zaehlerstand_Wasser++;
        verbrauch[viertelstunde].Wasser++;
      }else
      if (Wasserpegel && (x < WASSER_LOW)){
        Wasserpegel = 0;
      }
      if ( x > pegelMaxWasser) pegelMaxWasser = x;
      if ( x < pegelMinWasser) pegelMinWasser = x;
      channel=2;
      break;

    case 2: //Strom
      if (!Strompegel && (x > STROM_HIGH)){
        Strompegel = 1;
        strom_markierung=1; //Triggert bernahme der Umdrehungsdauer. Auswertung in Timer.c
        jetzt.Zaehlerstand_Strom++;
        verbrauch[viertelstunde].Strom++;
      }else
      if (Strompegel && (x < STROM_LOW)){
        Strompegel = 0;
      }
      if ( x > pegelMaxStrom) pegelMaxStrom = x;
      if ( x < pegelMinStrom) pegelMinStrom = x;
      channel=0;
      break;
      
    default: channel=0; break;  
  }
  //usart_write("Kanal(%i)=%i\n\r",(channel-1),var_array[(channel-1)]);
  ADMUX =(1<<REFS0) | (1<<ADLAR) | channel;
  //ANALOG_ON passiert in Timer.c
}
#endif


